//+------------------------------------------------------------------+
//|                                                       Series.mqh |
//|                                    Copyright (c) 2023, Marketeer |
//|                          https://www.mql5.com/en/users/marketeer |
//| obsolete (can be used to inject indicators                       |
//| into expressions bypassing setup)                                |
//+------------------------------------------------------------------+

#ifndef EXTENDED_FUNCTORS
  #define EXTENDED_FUNCTORS
#endif

#include "../Functors.mqh"


class IndHandlesFunc: public BaseFunc
{
  private:
    static BaseFuncFactory factory;
    
  protected:
    const int handle;
    
    static BaseFunc *legend(void)
    {
      const string msg = "Attached arbitrary indicator handles.";
      Print(msg);
      return NULL;
    }
    
  public:
    IndHandlesFunc(const string name, const int h): BaseFunc(name, 2), handle(h)
    {
    }
    
    static BaseFunc *create(const string name, const string = NULL, const ENUM_TIMEFRAMES = 0) // 'name=handle' pair
    {
      if(name == NULL)
      {
        return legend();
      }
      
      string result[];
      if(StringSplit(name, '=', result) != 2) return NULL;

      return new IndHandlesFunc(result[0], (int)StringToInteger(result[1]));
    }
    
    double execute(const double &params[]) override
    {
      const int buf = (int)params[0];
      const int bar = (int)params[1];
      
      static double result[1];
      return CopyBuffer(handle, buf, bar, 1, result) == 1 ? result[0] : nan;
    }
};

static BaseFuncFactory IndHandlesFunc::factory(IndHandlesFunc::create);
